/**
* @author Dirk Nordmann
* @date   24.01.2002
*/
package xml2rtf.rtf;

import util.Globals;
import java.util.*;

public class RtfTextSize 
{

  private static final double normalize = 2462.0;
  private static Hashtable char2width;
  
  public static int textSizeInTwips(String s, int size, boolean bold, boolean italic, boolean fixed)
  {
    int rtn = 0;
    for (int i = 0; i < s.length(); i++)
      rtn += (int)(((TextSizeInTwips)char2width.get("" + s.charAt(i))).getSize(bold,italic,fixed) * Globals.PIX2TWIPS * size / normalize);
    return rtn;
  }

  /*

  import java.awt.*;
  import java.awt.image.*;
    
  public static int textSizeInTwipsFromAwt(String s, int size, boolean bold, boolean italic, boolean fixed)
  {
    int style = Font.PLAIN;
    if(bold)
      style |= Font.BOLD;
    if(italic)
      style |= Font.ITALIC;

    int width = 1024;
    int height = 128;
    BufferedImage image = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration().createCompatibleImage(width, height);
    Graphics2D graphics = (Graphics2D)image.getGraphics();
    FontMetrics fontmetrics = graphics.getFontMetrics(new Font(fixed ? "monospaced" : "dialog", style, size));
    int rtn = (int)(fontmetrics.stringWidth(s) * Globals.PIX2TWIPS);
    return rtn;
  }

  */
  
  public static class TextSizeInTwips 
  {
    private int w_plain;
    private int w_bold;
    private int w_italic;
    private int w_bold_italic;
    private int w_fixed;
    
    /**
    * Constructor
    */
    public TextSizeInTwips(int w_plain, int w_bold, int w_italic, int w_bold_italic, int w_fixed)
    {
      this.w_plain = w_plain;
      this.w_bold = w_bold;
      this.w_italic = w_italic;
      this.w_bold_italic = w_bold_italic;
      this.w_fixed = w_fixed;
    }

    public int getSize(boolean bold, boolean italic, boolean fixed)
    {
      if (!bold && !italic && !fixed)
        return this.w_plain;
      else if (bold && !italic && !fixed)
        return this.w_bold;
      else if (!bold && italic && !fixed)
        return this.w_italic;
      else if (bold && italic && !fixed)
        return this.w_bold_italic;
      else
        return this.w_fixed;
    }
  }

  static
  {
    char2width = new Hashtable();
		char2width.put("" + (char)0,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)1,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)2,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)3,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)4,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)5,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)6,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)7,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)8,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)9,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)10,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)11,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)12,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)13,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)14,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)15,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)16,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)17,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)18,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)19,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)20,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)21,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)22,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)23,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)24,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)25,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)26,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)27,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)28,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)29,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)30,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)31,new TextSizeInTwips(0,0,0,0,0));
		char2width.put("" + (char)32,new TextSizeInTwips(700,700,700,700,1500)); //  
		char2width.put("" + (char)33,new TextSizeInTwips(700,800,700,825,1500)); // !
		char2width.put("" + (char)34,new TextSizeInTwips(900,1175,900,1175,1500)); // "
		char2width.put("" + (char)35,new TextSizeInTwips(1400,1400,1400,1400,1500)); // #
		char2width.put("" + (char)36,new TextSizeInTwips(1400,1400,1400,1400,1500)); // $
		char2width.put("" + (char)37,new TextSizeInTwips(2225,2200,2225,2250,1500)); // %
		char2width.put("" + (char)38,new TextSizeInTwips(1675,1800,1675,1800,1500)); // &
		char2width.put("" + (char)39,new TextSizeInTwips(475,600,475,550,1500)); // '
		char2width.put("" + (char)40,new TextSizeInTwips(825,825,825,825,1500)); // (
		char2width.put("" + (char)41,new TextSizeInTwips(825,825,825,825,1500)); // )
		char2width.put("" + (char)42,new TextSizeInTwips(975,975,975,975,1500)); // *
		char2width.put("" + (char)43,new TextSizeInTwips(1450,1450,1450,1450,1500)); // +
		char2width.put("" + (char)44,new TextSizeInTwips(700,700,700,700,1500)); // ,
		char2width.put("" + (char)45,new TextSizeInTwips(825,825,825,825,1500)); // -
		char2width.put("" + (char)46,new TextSizeInTwips(700,700,700,700,1500)); // .
		char2width.put("" + (char)47,new TextSizeInTwips(700,700,700,700,1500)); // /
		char2width.put("" + (char)48,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 0
		char2width.put("" + (char)49,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 1
		char2width.put("" + (char)50,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 2
		char2width.put("" + (char)51,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 3
		char2width.put("" + (char)52,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 4
		char2width.put("" + (char)53,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 5
		char2width.put("" + (char)54,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 6
		char2width.put("" + (char)55,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 7
		char2width.put("" + (char)56,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 8
		char2width.put("" + (char)57,new TextSizeInTwips(1400,1400,1400,1400,1500)); // 9
		char2width.put("" + (char)58,new TextSizeInTwips(700,850,700,825,1500)); // :
		char2width.put("" + (char)59,new TextSizeInTwips(700,850,700,825,1500)); // ;
		char2width.put("" + (char)60,new TextSizeInTwips(1450,1450,1450,1450,1500)); // <
		char2width.put("" + (char)61,new TextSizeInTwips(1450,1450,1450,1450,1500)); // =
		char2width.put("" + (char)62,new TextSizeInTwips(1450,1450,1450,1450,1500)); // >
		char2width.put("" + (char)63,new TextSizeInTwips(1400,1525,1400,1525,1500)); // ?
		char2width.put("" + (char)64,new TextSizeInTwips(2550,2450,2500,2450,1500)); // @
		char2width.put("" + (char)65,new TextSizeInTwips(1675,1725,1675,1800,1500)); // A
		char2width.put("" + (char)66,new TextSizeInTwips(1675,1800,1675,1800,1500)); // B
		char2width.put("" + (char)67,new TextSizeInTwips(1800,1800,1800,1800,1500)); // C
		char2width.put("" + (char)68,new TextSizeInTwips(1800,1800,1800,1800,1500)); // D
		char2width.put("" + (char)69,new TextSizeInTwips(1675,1675,1675,1675,1500)); // E
		char2width.put("" + (char)70,new TextSizeInTwips(1525,1525,1525,1525,1500)); // F
		char2width.put("" + (char)71,new TextSizeInTwips(1950,1950,1950,1950,1500)); // G
		char2width.put("" + (char)72,new TextSizeInTwips(1800,1800,1800,1800,1500)); // H
		char2width.put("" + (char)73,new TextSizeInTwips(700,700,700,700,1500)); // I
		char2width.put("" + (char)74,new TextSizeInTwips(1250,1400,1250,1400,1500)); // J
		char2width.put("" + (char)75,new TextSizeInTwips(1675,1800,1675,1800,1500)); // K
		char2width.put("" + (char)76,new TextSizeInTwips(1400,1525,1400,1525,1500)); // L
		char2width.put("" + (char)77,new TextSizeInTwips(2075,2075,2075,2075,1500)); // M
		char2width.put("" + (char)78,new TextSizeInTwips(1800,1800,1800,1800,1500)); // N
		char2width.put("" + (char)79,new TextSizeInTwips(1950,1950,1950,1950,1500)); // O
		char2width.put("" + (char)80,new TextSizeInTwips(1675,1675,1675,1675,1500)); // P
		char2width.put("" + (char)81,new TextSizeInTwips(1950,1950,1950,1950,1500)); // Q
		char2width.put("" + (char)82,new TextSizeInTwips(1800,1800,1800,1800,1500)); // R
		char2width.put("" + (char)83,new TextSizeInTwips(1675,1675,1675,1675,1500)); // S
		char2width.put("" + (char)84,new TextSizeInTwips(1550,1525,1525,1525,1500)); // T
		char2width.put("" + (char)85,new TextSizeInTwips(1800,1800,1800,1800,1500)); // U
		char2width.put("" + (char)86,new TextSizeInTwips(1675,1675,1675,1675,1500)); // V
		char2width.put("" + (char)87,new TextSizeInTwips(2475,2375,2400,2350,1500)); // W
		char2width.put("" + (char)88,new TextSizeInTwips(1650,1675,1675,1675,1500)); // X
		char2width.put("" + (char)89,new TextSizeInTwips(1650,1650,1675,1675,1500)); // Y
		char2width.put("" + (char)90,new TextSizeInTwips(1525,1525,1525,1525,1500)); // Z
		char2width.put("" + (char)91,new TextSizeInTwips(700,825,700,825,1500)); // [
		char2width.put("" + (char)92,new TextSizeInTwips(700,700,700,700,1500)); // \
		char2width.put("" + (char)93,new TextSizeInTwips(700,825,700,850,1500)); // ]
		char2width.put("" + (char)94,new TextSizeInTwips(1075,1450,1175,1450,1500)); // ^
		char2width.put("" + (char)95,new TextSizeInTwips(1400,1400,1400,1400,1500)); // _
		char2width.put("" + (char)96,new TextSizeInTwips(825,825,825,825,1500)); // `
		char2width.put("" + (char)97,new TextSizeInTwips(1400,1400,1400,1400,1500)); // a
		char2width.put("" + (char)98,new TextSizeInTwips(1400,1525,1400,1525,1500)); // b
		char2width.put("" + (char)99,new TextSizeInTwips(1250,1400,1250,1400,1500)); // c
		char2width.put("" + (char)100,new TextSizeInTwips(1400,1525,1400,1525,1500)); // d
		char2width.put("" + (char)101,new TextSizeInTwips(1400,1400,1400,1400,1500)); // e
		char2width.put("" + (char)102,new TextSizeInTwips(725,825,700,825,1500)); // f
		char2width.put("" + (char)103,new TextSizeInTwips(1375,1525,1400,1525,1500)); // g
		char2width.put("" + (char)104,new TextSizeInTwips(1400,1525,1400,1525,1500)); // h
		char2width.put("" + (char)105,new TextSizeInTwips(550,700,550,700,1500)); // i
		char2width.put("" + (char)106,new TextSizeInTwips(550,675,550,700,1500)); // j
		char2width.put("" + (char)107,new TextSizeInTwips(1250,1400,1250,1400,1500)); // k
		char2width.put("" + (char)108,new TextSizeInTwips(550,700,550,700,1500)); // l
		char2width.put("" + (char)109,new TextSizeInTwips(2100,2225,2050,2225,1500)); // m
		char2width.put("" + (char)110,new TextSizeInTwips(1400,1525,1400,1525,1500)); // n
		char2width.put("" + (char)111,new TextSizeInTwips(1400,1525,1400,1525,1500)); // o
		char2width.put("" + (char)112,new TextSizeInTwips(1400,1525,1400,1525,1500)); // p
		char2width.put("" + (char)113,new TextSizeInTwips(1375,1525,1400,1525,1500)); // q
		char2width.put("" + (char)114,new TextSizeInTwips(825,975,825,975,1500)); // r
		char2width.put("" + (char)115,new TextSizeInTwips(1250,1400,1250,1400,1500)); // s
		char2width.put("" + (char)116,new TextSizeInTwips(700,825,700,825,1500)); // t
		char2width.put("" + (char)117,new TextSizeInTwips(1400,1525,1400,1525,1500)); // u
		char2width.put("" + (char)118,new TextSizeInTwips(1225,1350,1250,1400,1500)); // v
		char2width.put("" + (char)119,new TextSizeInTwips(1775,2000,1825,1950,1500)); // w
		char2width.put("" + (char)120,new TextSizeInTwips(1225,1400,1250,1400,1500)); // x
		char2width.put("" + (char)121,new TextSizeInTwips(1225,1325,1250,1400,1500)); // y
		char2width.put("" + (char)122,new TextSizeInTwips(1225,1250,1175,1250,1500)); // z
		char2width.put("" + (char)123,new TextSizeInTwips(825,975,825,975,1500)); // {
		char2width.put("" + (char)124,new TextSizeInTwips(650,700,650,675,1500)); // |
		char2width.put("" + (char)125,new TextSizeInTwips(825,975,825,975,1500)); // }
		char2width.put("" + (char)126,new TextSizeInTwips(1450,1450,1450,1450,1500)); // ~
		char2width.put("" + (char)127,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)128,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)129,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)130,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)131,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)132,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)133,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)134,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)135,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)136,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)137,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)138,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)139,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)140,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)141,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)142,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)143,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)144,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)145,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)146,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)147,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)148,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)149,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)150,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)151,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)152,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)153,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)154,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)155,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)156,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)157,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)158,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)159,new TextSizeInTwips(1875,1975,1875,1975,1525));
		char2width.put("" + (char)160,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)161,new TextSizeInTwips(775,850,825,825,1500));
		char2width.put("" + (char)162,new TextSizeInTwips(1400,1400,1400,1450,1500));
		char2width.put("" + (char)163,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)164,new TextSizeInTwips(1400,1400,1350,1400,1500));
		char2width.put("" + (char)165,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)166,new TextSizeInTwips(650,700,650,700,1500));
		char2width.put("" + (char)167,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)168,new TextSizeInTwips(825,825,825,825,1500));
		char2width.put("" + (char)169,new TextSizeInTwips(1850,1850,1875,1850,1500));
		char2width.put("" + (char)170,new TextSizeInTwips(925,925,925,925,1500));
		char2width.put("" + (char)171,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)172,new TextSizeInTwips(1450,1450,1450,1450,1500));
		char2width.put("" + (char)173,new TextSizeInTwips(825,825,825,825,1500));
		char2width.put("" + (char)174,new TextSizeInTwips(1850,1850,1875,1850,1500));
		char2width.put("" + (char)175,new TextSizeInTwips(1375,1375,1375,1375,1500));
		char2width.put("" + (char)176,new TextSizeInTwips(1000,1000,1000,1000,1500));
		char2width.put("" + (char)177,new TextSizeInTwips(1375,1375,1375,1375,1500));
		char2width.put("" + (char)178,new TextSizeInTwips(825,825,825,825,1500));
		char2width.put("" + (char)179,new TextSizeInTwips(825,825,875,825,1500));
		char2width.put("" + (char)180,new TextSizeInTwips(825,825,825,825,1500));
		char2width.put("" + (char)181,new TextSizeInTwips(1450,1450,1375,1450,1500));
		char2width.put("" + (char)182,new TextSizeInTwips(1350,1400,1350,1375,1500));
		char2width.put("" + (char)183,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)184,new TextSizeInTwips(825,800,825,825,1500));
		char2width.put("" + (char)185,new TextSizeInTwips(825,825,775,825,1500));
		char2width.put("" + (char)186,new TextSizeInTwips(925,925,925,925,1500));
		char2width.put("" + (char)187,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)188,new TextSizeInTwips(2075,2075,2075,2075,1500));
		char2width.put("" + (char)189,new TextSizeInTwips(2075,2075,2075,2075,1500));
		char2width.put("" + (char)190,new TextSizeInTwips(2075,2075,2075,2075,1500));
		char2width.put("" + (char)191,new TextSizeInTwips(1525,1525,1525,1525,1500));
		char2width.put("" + (char)192,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)193,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)194,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)195,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)196,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)197,new TextSizeInTwips(1675,1725,1675,1800,1500));
		char2width.put("" + (char)198,new TextSizeInTwips(2500,2500,2500,2500,1500));
		char2width.put("" + (char)199,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)200,new TextSizeInTwips(1675,1675,1675,1675,1500));
		char2width.put("" + (char)201,new TextSizeInTwips(1675,1675,1675,1675,1500));
		char2width.put("" + (char)202,new TextSizeInTwips(1675,1675,1675,1675,1500));
		char2width.put("" + (char)203,new TextSizeInTwips(1675,1675,1675,1675,1500));
		char2width.put("" + (char)204,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)205,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)206,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)207,new TextSizeInTwips(700,700,700,700,1500));
		char2width.put("" + (char)208,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)209,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)210,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)211,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)212,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)213,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)214,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)215,new TextSizeInTwips(1450,1450,1450,1450,1500));
		char2width.put("" + (char)216,new TextSizeInTwips(1950,1950,1950,1950,1500));
		char2width.put("" + (char)217,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)218,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)219,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)220,new TextSizeInTwips(1800,1800,1800,1800,1500));
		char2width.put("" + (char)221,new TextSizeInTwips(1650,1650,1675,1675,1500));
		char2width.put("" + (char)222,new TextSizeInTwips(1675,1675,1675,1675,1500));
		char2width.put("" + (char)223,new TextSizeInTwips(1525,1525,1525,1525,1500));
		char2width.put("" + (char)224,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)225,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)226,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)227,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)228,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)229,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)230,new TextSizeInTwips(2225,2225,2225,2225,1500));
		char2width.put("" + (char)231,new TextSizeInTwips(1250,1400,1250,1400,1500));
		char2width.put("" + (char)232,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)233,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)234,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)235,new TextSizeInTwips(1400,1400,1400,1400,1500));
		char2width.put("" + (char)236,new TextSizeInTwips(675,700,700,700,1500));
		char2width.put("" + (char)237,new TextSizeInTwips(675,700,700,700,1500));
		char2width.put("" + (char)238,new TextSizeInTwips(675,700,700,700,1500));
		char2width.put("" + (char)239,new TextSizeInTwips(675,700,700,700,1500));
		char2width.put("" + (char)240,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)241,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)242,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)243,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)244,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)245,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)246,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)247,new TextSizeInTwips(1375,1375,1375,1375,1500));
		char2width.put("" + (char)248,new TextSizeInTwips(1525,1525,1525,1525,1500));
		char2width.put("" + (char)249,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)250,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)251,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)252,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)253,new TextSizeInTwips(1225,1325,1250,1400,1500));
		char2width.put("" + (char)254,new TextSizeInTwips(1400,1525,1400,1525,1500));
		char2width.put("" + (char)255,new TextSizeInTwips(1225,1325,1250,1400,1500));
  }

}